-- CONSTRAINTS.sql
--
-- Authors:     Prof. Dr. Thomas H. Kolbe <kolbe@igg.tu-berlin.de>
--              Gerhard Knig <gerhard.koenig@tu-berlin.de>
--              Claus Nagel <nagel@igg.tu-berlin.de>
--              Alexandra Stadler <stadler@igg.tu-berlin.de>
--
-- Copyright:   (c) 2007-2008  Institute for Geodesy and Geoinformation Science,
--                             Technische Universitt Berlin, Germany
--                             http://www.igg.tu-berlin.de
--
--              This skript is free software under the LGPL Version 2.1.
--              See the GNU Lesser General Public License at
--              http://www.gnu.org/copyleft/lgpl.html
--              for more details.
-------------------------------------------------------------------------------
-- About:
--
--
-------------------------------------------------------------------------------
--
-- ChangeLog:
--
-- Version | Date       | Description                               | Author
-- 2.0.0     2007-11-23   release version                             TKol
--                                                                    GKoe
--                                                                    CNag
--                                                                    ASta
--
--//ADDRESS_TO_BUILDING CONSTRAINTS

ALTER TABLE ADDRESS_TO_BUILDING
ADD CONSTRAINT ADDRESS_TO_BUILDING_FK FOREIGN KEY (BUILDING_ID)
REFERENCES BUILDING (ID) ENABLE;

ALTER TABLE ADDRESS_TO_BUILDING
ADD CONSTRAINT ADDRESS_TO_BUILDING_ADDRESS_FK FOREIGN KEY (ADDRESS_ID)
REFERENCES ADDRESS (ID) ENABLE;


--//APPEARANCE CONSTRAINTS

ALTER TABLE APPEARANCE
ADD CONSTRAINT APPEARANCE_CITYMODEL_FK FOREIGN KEY (CITYMODEL_ID)
REFERENCES CITYMODEL (ID) ENABLE;

ALTER TABLE APPEARANCE
ADD CONSTRAINT APPEARANCE_CITYOBJECT_FK FOREIGN KEY (CITYOBJECT_ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//APPEAR_TO_SURFACE_DATA CONSTRAINT

ALTER TABLE APPEAR_TO_SURFACE_DATA
ADD CONSTRAINT APPEAR_TO_SURFACE_DATA_FK1 FOREIGN KEY (APPEARANCE_ID)
REFERENCES APPEARANCE (ID) ENABLE;

ALTER TABLE APPEAR_TO_SURFACE_DATA
ADD CONSTRAINT APPEAR_TO_SURFACE_DATA_FK FOREIGN KEY (SURFACE_DATA_ID)
REFERENCES SURFACE_DATA (ID) ENABLE;


--//BREAKLINE_RELIEF CONSTRAINT

ALTER TABLE BREAKLINE_RELIEF
ADD CONSTRAINT BREAKLINE_RELIEF_FK FOREIGN KEY (ID)
REFERENCES RELIEF_COMPONENT (ID) ENABLE;


--//BUILDING CONSTRAINT

ALTER TABLE BUILDING
ADD CONSTRAINT BUILDING_SURFACE_GEOMETRY_FK FOREIGN KEY (LOD1_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING
ADD CONSTRAINT BUILDING_SURFACE_GEOMETRY_FK3 FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING
ADD CONSTRAINT BUILDING_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE BUILDING
ADD CONSTRAINT BUILDING_SURFACE_GEOMETRY_FK1 FOREIGN KEY (LOD2_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING
ADD CONSTRAINT BUILDING_SURFACE_GEOMETRY_FK2 FOREIGN KEY (LOD3_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING
ADD CONSTRAINT BUILDING_BUILDING_FK FOREIGN KEY (BUILDING_PARENT_ID)
REFERENCES BUILDING (ID) ENABLE;

ALTER TABLE BUILDING
ADD CONSTRAINT BUILDING_BUILDING_FK1 FOREIGN KEY (BUILDING_ROOT_ID)
REFERENCES BUILDING (ID) ENABLE;


--//BUILDING_FURNITURE CONSTRAINT

ALTER TABLE BUILDING_FURNITURE
ADD CONSTRAINT BUILDING_FURNITURE_FK1 FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE BUILDING_FURNITURE
ADD CONSTRAINT BUILDING_FURNITURE_FK2 FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING_FURNITURE
ADD CONSTRAINT BUILDING_FURNITURE_FK FOREIGN KEY (LOD4_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING_FURNITURE
ADD CONSTRAINT BUILDING_FURNITURE_ROOM_FK FOREIGN KEY (ROOM_ID)
REFERENCES ROOM (ID) ENABLE;


--//BUILDING_INSTALLATION CONSTRAINT

ALTER TABLE BUILDING_INSTALLATION
ADD CONSTRAINT BUILDING_INSTALLATION_FK3 FOREIGN KEY (LOD3_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING_INSTALLATION
ADD CONSTRAINT BUILDING_INSTALLATION_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE BUILDING_INSTALLATION
ADD CONSTRAINT BUILDING_INSTALLATION_ROOM_FK FOREIGN KEY (ROOM_ID)
REFERENCES ROOM (ID) ENABLE;

ALTER TABLE BUILDING_INSTALLATION
ADD CONSTRAINT BUILDING_INSTALLATION_FK4 FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE BUILDING_INSTALLATION
ADD CONSTRAINT BUILDING_INSTALLATION_FK1 FOREIGN KEY (BUILDING_ID)
REFERENCES BUILDING (ID) ENABLE;

ALTER TABLE BUILDING_INSTALLATION
ADD CONSTRAINT BUILDING_INSTALLATION_FK2 FOREIGN KEY (LOD2_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//CITYOBJECT CONSTRAINT

ALTER TABLE CITYOBJECT
ADD CONSTRAINT CITYOBJECT_OBJECTCLASS_FK FOREIGN KEY (CLASS_ID)
REFERENCES OBJECTCLASS (ID) ENABLE;


--//CITYOBJECTGROUP CONSTRAINT

ALTER TABLE CITYOBJECTGROUP
ADD CONSTRAINT CITYOBJECT_GROUP_FK FOREIGN KEY (SURFACE_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE CITYOBJECTGROUP
ADD CONSTRAINT CITYOBJECTGROUP_CITYOBJECT_FK FOREIGN KEY (PARENT_CITYOBJECT_ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE CITYOBJECTGROUP
ADD CONSTRAINT CITYOBJECTGROUP_CITYOBJECT_FK1 FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//CITYOBJECT_GENERICATTRIB CONSTRAINT

ALTER TABLE CITYOBJECT_GENERICATTRIB
ADD CONSTRAINT CITYOBJECT_GENERICATTRIB_FK FOREIGN KEY (CITYOBJECT_ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE CITYOBJECT_GENERICATTRIB
ADD CONSTRAINT CITYOBJECT_GENERICATTRIB_FK1 FOREIGN KEY (SURFACE_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//CITYOBJECT_MEMBER CONSTRAINT

ALTER TABLE CITYOBJECT_MEMBER
ADD CONSTRAINT CITYOBJECT_MEMBER_CITYMODEL_FK FOREIGN KEY (CITYMODEL_ID)
REFERENCES CITYMODEL (ID) ENABLE;

ALTER TABLE CITYOBJECT_MEMBER
ADD CONSTRAINT CITYOBJECT_MEMBER_FK FOREIGN KEY (CITYOBJECT_ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//CITY_FURNITURE CONSTRAINT

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK FOREIGN KEY (LOD1_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK1 FOREIGN KEY (LOD2_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK2 FOREIGN KEY (LOD3_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK3 FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK4 FOREIGN KEY (LOD1_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK5 FOREIGN KEY (LOD2_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK6 FOREIGN KEY (LOD3_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_FK7 FOREIGN KEY (LOD4_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE CITY_FURNITURE
ADD CONSTRAINT CITY_FURNITURE_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//EXTERNAL_REFERENCE CONSTRAINT

ALTER TABLE EXTERNAL_REFERENCE
ADD CONSTRAINT EXTERNAL_REFERENCE_FK FOREIGN KEY (CITYOBJECT_ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//GENERALIZATION CONSTRAINT

ALTER TABLE GENERALIZATION
ADD CONSTRAINT GENERALIZATION_FK1 FOREIGN KEY (GENERALIZES_TO_ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE GENERALIZATION
ADD CONSTRAINT GENERALIZATION_FK FOREIGN KEY (CITYOBJECT_ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//GENERIC_CITYOBJECT CONSTRAINT

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK FOREIGN KEY (LOD0_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK1 FOREIGN KEY (LOD1_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK2 FOREIGN KEY (LOD2_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK3 FOREIGN KEY (LOD3_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK4 FOREIGN KEY (LOD4_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK5 FOREIGN KEY (LOD0_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK6 FOREIGN KEY (LOD1_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK7 FOREIGN KEY (LOD2_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK8 FOREIGN KEY (LOD3_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK9 FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE GENERIC_CITYOBJECT
ADD CONSTRAINT GENERIC_CITYOBJECT_FK10 FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//GROUP_TO_CITYOBJECT CONSTRAINT

ALTER TABLE GROUP_TO_CITYOBJECT
ADD CONSTRAINT GROUP_TO_CITYOBJECT_FK FOREIGN KEY (CITYOBJECT_ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE GROUP_TO_CITYOBJECT
ADD CONSTRAINT GROUP_TO_CITYOBJECT_FK1 FOREIGN KEY (CITYOBJECTGROUP_ID)
REFERENCES CITYOBJECTGROUP (ID) ENABLE;

ALTER TABLE IMPLICIT_GEOMETRY
ADD CONSTRAINT IMPLICIT_GEOMETRY_FK FOREIGN KEY (RELATIVE_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//LAND_USE CONSTRAINT

ALTER TABLE LAND_USE
ADD CONSTRAINT LAND_USE_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE LAND_USE
ADD CONSTRAINT LAND_USE_SURFACE_GEOMETRY_FK FOREIGN KEY (LOD0_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE LAND_USE
ADD CONSTRAINT LAND_USE_SURFACE_GEOMETRY_FK1 FOREIGN KEY (LOD1_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE LAND_USE
ADD CONSTRAINT LAND_USE_SURFACE_GEOMETRY_FK2 FOREIGN KEY (LOD2_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE LAND_USE
ADD CONSTRAINT LAND_USE_SURFACE_GEOMETRY_FK3 FOREIGN KEY (LOD3_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE LAND_USE
ADD CONSTRAINT LAND_USE_SURFACE_GEOMETRY_FK4 FOREIGN KEY (LOD4_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//MASSPOINT_RELIEF CONSTRAINT

ALTER TABLE MASSPOINT_RELIEF
ADD CONSTRAINT MASSPOINT_RELIEF_FK FOREIGN KEY (ID)
REFERENCES RELIEF_COMPONENT (ID) ENABLE;


--//OBJECTCLASS CONSTRAINT

ALTER TABLE OBJECTCLASS
ADD CONSTRAINT OBJECTCLASS_OBJECTCLASS_FK FOREIGN KEY (SUPERCLASS_ID)
REFERENCES OBJECTCLASS (ID) ENABLE;


--//OPENING CONSTRAINT

ALTER TABLE OPENING
ADD CONSTRAINT OPENING_SURFACE_GEOMETRY_FK1 FOREIGN KEY (LOD4_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE OPENING
ADD CONSTRAINT OPENING_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE OPENING
ADD CONSTRAINT OPENING_SURFACE_GEOMETRY_FK FOREIGN KEY (LOD3_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE OPENING
ADD CONSTRAINT OPENING_ADDRESS_FK FOREIGN KEY (ADDRESS_ID)
REFERENCES ADDRESS (ID) ENABLE;


--//OPENING_TO_THEM_SURFACE CONSTRAINT

ALTER TABLE OPENING_TO_THEM_SURFACE
ADD CONSTRAINT OPENING_TO_THEMATIC_SURFACE_FK FOREIGN KEY (OPENING_ID)
REFERENCES OPENING (ID) ENABLE;

ALTER TABLE OPENING_TO_THEM_SURFACE
ADD CONSTRAINT OPENING_TO_THEMATIC_SURFAC_FK1 FOREIGN KEY (THEMATIC_SURFACE_ID)
REFERENCES THEMATIC_SURFACE (ID) ENABLE;


--//PLANT_COVER CONSTRAINT

ALTER TABLE PLANT_COVER
ADD CONSTRAINT PLANT_COVER_FK FOREIGN KEY (LOD1_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE PLANT_COVER
ADD CONSTRAINT PLANT_COVER_FK1 FOREIGN KEY (LOD2_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE PLANT_COVER
ADD CONSTRAINT PLANT_COVER_FK3 FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE PLANT_COVER
ADD CONSTRAINT PLANT_COVER_FK2 FOREIGN KEY (LOD3_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE PLANT_COVER
ADD CONSTRAINT PLANT_COVER_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//RELIEF_COMPONENT CONSTRAINT

ALTER TABLE RELIEF_COMPONENT
ADD CONSTRAINT RELIEF_COMPONENT_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE RELIEF_COMPONENT
ADD CONSTRAINT RELIEF_COMPONENT_CHK1 CHECK (LOD>=0 AND LOD<5) ENABLE;


--//RELIEF_FEATURE CONSTRAINT

ALTER TABLE RELIEF_FEATURE
ADD CONSTRAINT RELIEF_FEATURE_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE RELIEF_FEATURE
ADD CONSTRAINT RELIEF_FEATURE_CHK1 CHECK (LOD>=0 AND LOD<5) ENABLE;


--//RELIEF_FEAT_TO_REL_COMP CONSTRAINT

ALTER TABLE RELIEF_FEAT_TO_REL_COMP
ADD CONSTRAINT RELIEF_FEAT_TO_REL_COMP_FK FOREIGN KEY (RELIEF_COMPONENT_ID)
REFERENCES RELIEF_COMPONENT (ID) ENABLE;

ALTER TABLE RELIEF_FEAT_TO_REL_COMP
ADD CONSTRAINT RELIEF_FEAT_TO_REL_COMP_FK1 FOREIGN KEY (RELIEF_FEATURE_ID)
REFERENCES RELIEF_FEATURE (ID) ENABLE;


--//ROOM CONSTRAINT

ALTER TABLE ROOM
ADD CONSTRAINT ROOM_BUILDING_FK FOREIGN KEY (BUILDING_ID)
REFERENCES BUILDING (ID) ENABLE;

ALTER TABLE ROOM
ADD CONSTRAINT ROOM_SURFACE_GEOMETRY_FK FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE ROOM
ADD CONSTRAINT ROOM_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;


--//SOLITARY_VEGETAT_OBJECT CONSTRAINT

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK1 FOREIGN KEY (LOD1_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK2 FOREIGN KEY (LOD2_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK3 FOREIGN KEY (LOD3_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK4 FOREIGN KEY (LOD4_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK5 FOREIGN KEY (LOD1_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK6 FOREIGN KEY (LOD2_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK7 FOREIGN KEY (LOD3_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;

ALTER TABLE SOLITARY_VEGETAT_OBJECT
ADD CONSTRAINT SOLITARY_VEGETAT_OBJECT_FK8 FOREIGN KEY (LOD4_IMPLICIT_REP_ID)
REFERENCES IMPLICIT_GEOMETRY (ID) ENABLE;


--//SURFACE_GEOMETRY CONSTRAINT

ALTER TABLE SURFACE_GEOMETRY
ADD CONSTRAINT SURFACE_GEOMETRY_FK FOREIGN KEY (PARENT_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE SURFACE_GEOMETRY
ADD CONSTRAINT SURFACE_GEOMETRY_FK1 FOREIGN KEY (ROOT_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//TEXTUREPARAM CONSTRAINT

ALTER TABLE TEXTUREPARAM
ADD CONSTRAINT TEXTUREPARAM_SURFACE_GEOM_FK FOREIGN KEY (SURFACE_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TEXTUREPARAM
ADD CONSTRAINT TEXTUREPARAM_SURFACE_DATA_FK FOREIGN KEY (SURFACE_DATA_ID)
REFERENCES SURFACE_DATA (ID) ENABLE;


--//THEMATIC_SURFACE CONSTRAINT

ALTER TABLE THEMATIC_SURFACE
ADD CONSTRAINT THEMATIC_SURFACE_ROOM_FK FOREIGN KEY (ROOM_ID)
REFERENCES ROOM (ID) ENABLE;

ALTER TABLE THEMATIC_SURFACE
ADD CONSTRAINT THEMATIC_SURFACE_BUILDING_FK FOREIGN KEY (BUILDING_ID)
REFERENCES BUILDING (ID) ENABLE;

ALTER TABLE THEMATIC_SURFACE
ADD CONSTRAINT THEMATIC_SURFACE_FK FOREIGN KEY (LOD2_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE THEMATIC_SURFACE
ADD CONSTRAINT THEMATIC_SURFACE_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE THEMATIC_SURFACE
ADD CONSTRAINT THEMATIC_SURFACE_FK2 FOREIGN KEY (LOD4_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE THEMATIC_SURFACE
ADD CONSTRAINT THEMATIC_SURFACE_FK1 FOREIGN KEY (LOD3_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//TIN_RELIEF CONSTRAINT

ALTER TABLE TIN_RELIEF
ADD CONSTRAINT TIN_RELIEF_SURFACE_GEOMETRY_FK FOREIGN KEY (SURFACE_GEOMETRY_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TIN_RELIEF
ADD CONSTRAINT TIN_RELIEF_RELIEF_COMPONENT_FK FOREIGN KEY (ID)
REFERENCES RELIEF_COMPONENT (ID) ENABLE;


--//TRAFFIC_AREA CONSTRAINT

ALTER TABLE TRAFFIC_AREA
ADD CONSTRAINT TRAFFIC_AREA_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE TRAFFIC_AREA
ADD CONSTRAINT TRAFFIC_AREA_FK FOREIGN KEY (LOD2_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TRAFFIC_AREA
ADD CONSTRAINT TRAFFIC_AREA_FK1 FOREIGN KEY (LOD3_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TRAFFIC_AREA
ADD CONSTRAINT TRAFFIC_AREA_FK2 FOREIGN KEY (LOD4_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TRAFFIC_AREA
ADD CONSTRAINT TRAFFIC_AREA_FK3 FOREIGN KEY (TRANSPORTATION_COMPLEX_ID)
REFERENCES TRANSPORTATION_COMPLEX (ID) ENABLE;


--//TRANSPORTATION_COMPLEX CONSTRAINT

ALTER TABLE TRANSPORTATION_COMPLEX
ADD CONSTRAINT TRANSPORTATION_COMPLEX_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE TRANSPORTATION_COMPLEX
ADD CONSTRAINT TRANSPORTATION_COMPLEX_FK1 FOREIGN KEY (LOD1_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TRANSPORTATION_COMPLEX
ADD CONSTRAINT TRANSPORTATION_COMPLEX_FK2 FOREIGN KEY (LOD2_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TRANSPORTATION_COMPLEX
ADD CONSTRAINT TRANSPORTATION_COMPLEX_FK3 FOREIGN KEY (LOD3_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE TRANSPORTATION_COMPLEX
ADD CONSTRAINT TRANSPORTATION_COMPLEX_FK4 FOREIGN KEY (LOD4_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//WATERBODY CONSTRAINT

ALTER TABLE WATERBODY
ADD CONSTRAINT WATERBODY_CITYOBJECT_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE WATERBODY
ADD CONSTRAINT WATERBODY_SURFACE_GEOMETRY_FK1 FOREIGN KEY (LOD2_SOLID_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE WATERBODY
ADD CONSTRAINT WATERBODY_SURFACE_GEOMETRY_FK2 FOREIGN KEY (LOD3_SOLID_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE WATERBODY
ADD CONSTRAINT WATERBODY_SURFACE_GEOMETRY_FK3 FOREIGN KEY (LOD4_SOLID_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE WATERBODY
ADD CONSTRAINT WATERBODY_SURFACE_GEOMETRY_FK4 FOREIGN KEY (LOD0_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE WATERBODY
ADD CONSTRAINT WATERBODY_SURFACE_GEOMETRY_FK5 FOREIGN KEY (LOD1_MULTI_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE WATERBODY
ADD CONSTRAINT WATERBODY_SURFACE_GEOMETRY_FK FOREIGN KEY (LOD1_SOLID_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;


--//WATERBOD_TO_WATERBND_SRF CONSTRAINT

ALTER TABLE WATERBOD_TO_WATERBND_SRF
ADD CONSTRAINT WATERBOD_TO_WATERBND_FK FOREIGN KEY (WATERBOUNDARY_SURFACE_ID)
REFERENCES WATERBOUNDARY_SURFACE (ID) ENABLE;

ALTER TABLE WATERBOD_TO_WATERBND_SRF
ADD CONSTRAINT WATERBOD_TO_WATERBND_FK1 FOREIGN KEY (WATERBODY_ID)
REFERENCES WATERBODY (ID) ENABLE;

ALTER TABLE WATERBOUNDARY_SURFACE
ADD CONSTRAINT WATERBOUNDARY_SRF_CITYOBJ_FK FOREIGN KEY (ID)
REFERENCES CITYOBJECT (ID) ENABLE;

ALTER TABLE WATERBOUNDARY_SURFACE
ADD CONSTRAINT WATERBOUNDARY_SURFACE_FK FOREIGN KEY (LOD2_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE WATERBOUNDARY_SURFACE
ADD CONSTRAINT WATERBOUNDARY_SURFACE_FK1 FOREIGN KEY (LOD3_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;

ALTER TABLE WATERBOUNDARY_SURFACE
ADD CONSTRAINT WATERBOUNDARY_SURFACE_FK2 FOREIGN KEY (LOD4_SURFACE_ID)
REFERENCES SURFACE_GEOMETRY (ID) ENABLE;